<template>
  <div class="left-form-container-wrapper">
    <div class="left-form-container-bg">
      <transition :name="transitionName">
        <div
          v-if="showPanel"
          class="left-form-container"
        >
          <div class="left-form-header">
            <div
              v-if="isBack"
              class="go-to-back"
              @click.stop="goBack"
            >
              <i class="icon chevron-left -cobalt" />
            </div>
            <div class="left-form-header__title">
              {{ title }}
            </div>
          </div>
          <div class="left-form-content">
            <slot />
          </div>
          <div
            v-if="$slots['footer']"
            class="left-form-footer"
          >
            <slot name="footer" />
          </div>
        </div>
      </transition>
    </div>
    <div class="left-form-bg">
      <transition
        v-if="currentHostname === 'oboz'"
        name="leftFormBg"
      >
        <div
          v-if="showPanel"
          class="background-block"
          :class="'body-bg-' + background"
        />
      </transition>
      <div
        v-else-if="currentHostname === 'gruzi'"
        class="background-block body-bg-gruzi"
      />
      <div
        v-if="showInfoMessage"
        :class="[ 'info-message', { '-white': currentHostname === 'oboz' } ]"
      >
        Если у вас возникают трудности при регистрации,<br>
        свяжитесь со службой поддержки платформы

        <template v-if="currentHostname === 'oboz'">
          Обоз<br> по телефону +7 (495) 646-06-03 или почте
          <a class="info-message__link" href="mailto:support@oboz.app">support@oboz.app</a>
        </template>

        <template v-else>
          Грузи.Ру<br> по телефону +7 (495) 260-17-78 или почте
          <a class="info-message__link" href="mailto:support@gruzi.ru">support@gruzi.ru</a>
        </template>
      </div>
    </div>
    <div
      v-if="currentHostname === 'gruzi'"
      class="info-message-bottom"
    >
      ООО “Грузи.Ру” 125167, Москва, Ленинградский проспект, д.37, корп. 3, эт.9, пом. XI,
      ком. 13. ИНН 7729632882, КПП 771401001.
      Техподдержка: <a href="mailto:support@gruzi.ru">support@gruzi.ru</a>, +7 (495) 260-17-78

      <br>

      <a
        :href="`https://legal.gruzi.ru/privacy_agreement.pdf?h=${uuid.v4()}`"
        class="document-link first"
        target="_blank"
      >
        Согласие на обработку персональных данных
      </a>

      <a
        :href="`https://legal.gruzi.ru/privacy_policy.pdf?h=${uuid.v4()}`"
        class="document-link"
        target="_blank"
      >
        Политика конфиденциальности
      </a>
    </div>
  </div>
</template>

<script>
import { uuid } from 'vue-uuid'

export default {
  name: 'LeftFormWrapper',
  inject: ['rootPageComponent'],
  props: {
    title: {
      type: String,
      default: ''
    },
    isBack: {
      type: Boolean,
      default: true
    },
    background: {
      type: String,
      default: '1'
    },
    showInfoMessage: {
      type: Boolean,
      default: false
    },
    backHandler: {
      type: Function,
      default: null
    }
  },
  computed: {
    showPanel () {
      return this.rootPageComponent.showLeftPanel
    },
    fromRoute () {
      return this.rootPageComponent.fromRoute
    },
    toRoute () {
      return this.rootPageComponent.toRoute
    },
    isFromHome () {
      return this.fromRoute && this.fromRoute.name === 'home'
    },
    isNotFromRoute () {
      return this.fromRoute && this.fromRoute.name === null
    },
    isToHome () {
      return this.toRoute && this.toRoute.name === 'home'
    },
    transitionName () {
      return ((this.isFromHome || this.isNotFromRoute) && !this.toRoute) || this.isToHome ? 'fade-panel' : 'slide-panel'
    },
    currentHostname () {
      return window.location.host.split('gruzi').length > 1 ? 'gruzi': 'oboz'
    },
  },
  data() {
    return {
      uuid
    }
  },
  methods: {
    goBack () {
      if (this.backHandler) {
        this.backHandler();
      } else {
        this.rootPageComponent?.handleBack()
      }
    }
  }
}
</script>

<style lang="scss" scoped>
    @import "~common-components/src/assets/style/ob-style";
    .left-form {
        &-container-wrapper {
            display: grid;
            grid-template-areas:
              'left-form-container-bg left-form-bg'
              'info-message-bottom    info-message-bottom';
            grid-template-columns: 462px 1fr;
            grid-template-rows: 1fr min-content;
            justify-content: space-between;
            width: 100vw;
            height: 100%;
            background-repeat: no-repeat;
            background-position: center center;
            background-size: cover;
        }
        &-bg {
            grid-area: left-form-bg;
            position: relative;
        }
        &-container-bg {
            grid-area: left-form-container-bg;
            background: white;
            padding: 40px 60px;
            overflow: hidden;
            overflow-y: auto;
        }
        &-container {
            display: flex;
            flex-direction: column;
            min-height: 100%;
        }
        &-header {
            position: relative;
            margin-bottom: 40px;
            &__title {
                @include font-mixin(28px, 36px, 400, $color-text-base, 0.4px);
            }
            .go-to-back {
                display: flex;
                align-items: center;
                cursor: pointer;
                position: absolute;
                font-size: 24px;
                top: 6px;
                left: -40px;
                width: 24px;
                height: 24px;
            }
        }
        &-content {
            flex: 1 0 auto;
        }
        &-footer {
            flex: 0 0 auto;
            margin-top: 40px;
            @include font-mixin(14px, 20px, 400, #9DA0AC, 0.2px);
        }
    }

    .slide-panel-enter, .slide-panel-leave-to {
        transform: translateX(-30%);
        opacity: 0;
    }
    .slide-panel-enter-active, .slide-panel-leave-active {
        transition: transform .3s ease-in-out, opacity .2s .1s ease-in-out;
    }

    .fade-panel-enter, .fade-panel-leave-to {
        opacity: 0;
    }
    .fade-panel-enter-active, .fade-panel-leave-active {
        transition: opacity .3s ease-in-out;
    }

    .background-block {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
    }

    .body-bg-gruzi {
      background-size: cover;
      background-position: center center;
      background-image: url('~@/assets/images/gruzi_bg.png');
    }

    .info-message {
      position: absolute;
      left: 40px;
      bottom: 40px;
      font-size: 12px;
      line-height: 14px;
      color: $shale-gray;

      &.-white {
        a {
          color: $blue-600;
        }
      }

      &__link {
        color: $shale-gray;
      }
    }

    .info-message-bottom {
      @include font-mixin(12px, 12px, normal, $style-white, 0.4px);

      grid-area: info-message-bottom;
      padding: 21px 30px 0;
      height: 80px;
      background-color: $green-800;
      width: 100%;

      a {
        color: $Green-300;
        text-decoration: none;

        &.document-link {
          margin-top: 10px;
          display: inline-block;

          &.first {
            margin-right: 28px;
          }
        }
      }
    }
</style>

<style lang="scss">
    @import "~common-components/src/assets/style/ob-style";
    .left-form-footer {
        a {
            @include font-mixin(14px, 20px, 400, $color-blue-navy-blue, 0.2px, none, none);
        }
    }
</style>
